;
;	EUREKA SCROLL TEXT SEKA VERSION
;

ORG	$20000
LOAD	$20000 

	lea	ecran,a0			;netoie l'ecran
	move	#44*272*3/4,d0
bclcl:	clr.l	(a0)+
	dbra	d0,bclcl

	lea	tampon_scroll,a0		;netoie le tampon
	move	#46*26*3/4,d0			;du scrolling
bclcl1:	clr.l	(a0)+				
	dbra	d0,bclcl1

	lea	vide,a0				;netoie le tampon
	move	#44*29*3/4,d0			;de vide
bclcl2:	clr.l	(a0)+
	dbra	d0,bclcl2

	lea	logo,a0				;copy le logo a l'ecran
	lea	ecran+[132*8],a1		;bitplan1
	move	#93,d0
bclcl3:	move	#19,d1
bclcl4:	move	(a0)+,(a1)+
	dbra	d1,bclcl4
	adda.l	#92,a1
	dbra	d0,bclcl3

	lea	logo+3760,a0			;copy le logo a l'ecran
	lea	ecran+44+[132*8],a1		;bitplan2
	move	#93,d0
bclcl5:	move	#19,d1
bclcl6:	move	(a0)+,(a1)+
	dbra	d1,bclcl6
	adda.l	#92,a1
	dbra	d0,bclcl5

	lea	logo+7520,a0			;copy le logo a l'ecran
	lea	ecran+88+[132*8],a1		;bitplan3
	move	#93,d0
bclcl7:	move	#19,d1
bclcl8:	move	(a0)+,(a1)+
	dbra	d1,bclcl8
	adda.l	#92,a1
	dbra	d0,bclcl7

	bsr	prepare_coppers_listes
	bsr	save_all

	move	#$3fff,$9a(a6)			
	move	#$c010,$9a(a6)			
	move	#$3fff,$96(a6)			
	move	#$83c0,$96(a6)

	move	#%0011001000000000,$100(a6)	
	move	#$2179,$8e(a6)	; diwstrt	
	move	#$31d9,$90(a6)	; diwstop 
	move	#$0030,$92(a6)	; ddfstrt
	move	#$00d8,$94(a6)  ; ddfstop
	move	#88,$108(a6)	; modulo
	move	#88,$10a(a6)
	move	#$0000,$102(a6)

	move.l	#irq,$6c		
	move.l	#copper_liste,$80(a6)		
	clr.w	$88(a6)

bloque:	btst	#6,$bfe001			;attent
	bne	bloque				;la souris

	bsr	restore_all
	moveq	#0,d0	
	rts					
**************************************************************
irq:	movem.l	d0-d7/a0-a6,-(sp)		
	move	$dff01e,d0
	and	$dff01c,d0
	btst	#4,d0				
	beq	fin_irq

	bsr	scroll_text

	move	#$10,$9c(a6)
fin_irq:
	movem.l	(sp)+,d0-d7/a0-a6
	rte					
**************************************************************
prepare_coppers_listes:	
	move.l	#ecran,d0			;adresse de l'ecran
	move.l	#ecran+44,d1
	move.l	#ecran+88,d2
	lea	copper_liste,a0
	lea	degrade,a1

	move	#$00e0,(a0)+			
	swap	d0				
	move	d0,(a0)+
	swap	d0
	move	#$00e2,(a0)+
	move	d0,(a0)+

	move	#$00e4,(a0)+			
	swap	d1				
	move	d1,(a0)+
	swap	d1
	move	#$00e6,(a0)+
	move	d1,(a0)+

	move	#$00e8,(a0)+			
	swap	d2				
	move	d2,(a0)+
	swap	d2
	move	#$00ea,(a0)+
	move	d2,(a0)+

	move.l	#$009c8010,(a0)+		

	move.l	#$01800000,(a0)+		
	move.l	#$01820fff,(a0)+	
	move.l	#$01840ddd,(a0)+	
	move.l	#$01860bbb,(a0)+	
	move.l	#$01880999,(a0)+	
	move.l	#$018a0888,(a0)+	
	move.l	#$018c0666,(a0)+	
	move.l	#$018e0444,(a0)+	

	move.l	#$8A01fffe,(a0)+

	move.l	#$01800000,(a0)+		
	move.l	#$01820ddd,(a0)+	
	move.l	#$01840ccc,(a0)+	
	move.l	#$01860aaa,(a0)+	
	move.l	#$01880888,(a0)+	
	move.l	#$018a0666,(a0)+	
	move.l	#$018c0444,(a0)+	
	move.l	#$018e0006,(a0)+	

	move.l	#$fffffffe,(a0)+
	rts
***************************************************************
scroll_text:
	moveq	#0,d0
	moveq	#0,d1

	cmp	#32,pointeur_let		;si la lettre a entierement
	blt	cont_scrol			;scrolle

	clr	pointeur_let
	move	pointeur_txt,d0
	lea	message,a0
	move.b	(a0,d0.w),d1
	add	#1,pointeur_txt			;on incremente le compteur

	cmp.b	#32,d1				;si caractere de controle
	blt	controle

	lea	tbl_code,a0			;on cherche l'adresse
	lsl	#2,d1				;de la lettre mais il
	move.l	(a0,d1.w),d1			;faudra ajouter l'addresse de
	bra	place_let			;la table des lettres
*********
controle:
	tst.b	d1				;si '0' alors
	bne	suite_ctrl			;on recommence
	clr	pointeur_txt
	move	#32,pointeur_let
	bra	scroll_text
suite_ctrl:
	cmp	#1,d1				;si '1' alors
	bne	suite_ctrl1			;on s'arrete
	move.b	1(a0,d0.w),stop
	add	#1,pointeur_txt
	bra	cont_scrol
suite_ctrl1:
	cmp	#2,d1				;si '2' alors
	bne	suite_ctrl2			;on met la vitesse
	move.b	1(a0,d0.w),vitesse+1
	add	#1,pointeur_txt
	move	#32,pointeur_let
	bra	cont_scrol
suite_ctrl2:
	cmp	#3,d1				;si '3' alors
	bne	suite_ctrl3			;on met la position
	move.b	1(a0,d0.w),d0			;en y du scroll
	and	#$ff,d0
	lsl	#4,d0
	move	d0,y_pos
	add	#1,pointeur_txt
	bra	cont_scrol
suite_ctrl3:
	cmp	#4,d1				;si '4' alors
	bne	suite_ctrl4			;on met la perte
	move.b	1(a0,d0.w),perte+1
	add	#1,pointeur_txt
	bra	cont_scrol
suite_ctrl4:
	cmp	#5,d1				;si '5' alors
	bne	suite_ctrl5			;on met la vitesse 
	move	#0,vitesse_y
	move.b	1(a0,d0.w),vitesse_y+1		;de la descente
	add	#1,pointeur_txt
	bra	cont_scrol
suite_ctrl5:
	cmp	#6,d1				;si '6' alors
	bne	suite_ctrl6			;on met l'acceleration
	move.b	1(a0,d0.w),acceleration+1
	add	#1,pointeur_txt
	bra	cont_scrol
suite_ctrl6:
	cmp	#7,d1				;si '7' alors
	bne	suite_ctrl7			;on demare le rebond
	move	#1,flag_rebond
	bra	cont_scrol
suite_ctrl7:
	cmp	#8,d1				;si '8' alors
	bne	suite_ctrl8			;on arrete le rebond
	move	#0,flag_rebond
	bra	cont_scrol
suite_ctrl8:
	rts
*********
Place_let:
	lea	image_let,a0
	add.l	d1,a0				;adresse de la lettre

	lea	tampon_scroll+44,a1		;destination

	move	#25,d0
bcl_copy:
	move.l	(a0),(a1)
	move.l	5200(a0),48(a1)
	move.l	10400(a0),96(a1)

	adda.l	#40,a0
	adda.l	#144,a1
	dbra	d0,bcl_copy
*********
cont_scrol:
	cmp.b	#0,stop
	beq	cont_scrol1
	add.b	#1,stop
	move	#31,pointeur_let
	bra	place_tam_ecr
cont_scrol1:
	lea	$dff000,a6
	move.l	#$ffff,d1

	move	d1,$44(a6)
	move	d1,$46(a6)
	move	#0,$64(a6)
	move	#0,$66(a6)
	
	move	vitesse,d0
	neg	d0
	and.l	#$f,d0
	ror.l	#4,d0
	or.l	#$9f00000,d0
	move.l	d0,$40(a6)

	move.l	#tampon_scroll+2,$50(a6)
	move.l	#tampon_scroll,$54(a6)

	move	#78*64+24,$58(a6)

attent:	btst	#14,$2(a6)
	bne	attent

	move	vitesse,d0
	add	d0,pointeur_let
*********
place_tam_ecr:

	cmp	#0,flag_rebond				;si 0 on rebondis pas
	beq	suite_place_tampon

	move	acceleration,d0
	add	d0,vitesse_y				;v=v+a
	move	vitesse_y,d0
	add	d0,y_pos				;y=y+v

	cmp	#250*16,y_pos				;if y>250
	ble	suite_place_tampon

	neg	y_pos
	addi	#500*16,y_pos				;y=500-y

	sub	perte,d0
	move	d0,vitesse_y				;v=v-p

	neg	vitesse_y				;v=-v

suite_place_tampon:
	move	y_pos,d0
	lsr	#4,d0
	muls	#132,d0
	lea	ecran,a0
	add.l	d0,a0					;adresse du scroll

	move	d1,$44(a6)				;efface le scroll
	move	d1,$46(a6)
	move	#4,$64(a6)
	move	#0,$66(a6)
	
	move.l	#$9f00000,$40(a6)

	move.l	#vide,$50(a6)
	move.l	sauve_adr_scro,$54(a6)

	move	#78*64+22,$58(a6)

attent2:
	btst	#14,$2(a6)
	bne	attent2

	move	d1,$44(a6)				;affiche le scroll
	move	d1,$46(a6)
	move	#4,$64(a6)
	move	#0,$66(a6)

	move.l	#$9f00000,$40(a6)

	move.l	#tampon_scroll,$50(a6)
	move.l	a0,$54(a6)

	move	#78*64+22,$58(a6)
attent1:
	btst	#14,$2(a6)
	bne	attent1

	move.l	a0,sauve_adr_scro
	rts
****************************************************************
save_all:
	move.b	#%10000111,$bfd100		; sauve un peu	
	move.l	4,a6				; tout
	jsr	-132(a6)
	lea	$dff000,a6
	move.l	$6c,sauv_irq
	move.w	$1c(a6),sauv_intena
	or.w	#$8100,sauv_intena
	move	2(a6),sauv_dmacon
	or.w	#$c000,sauv_dmacon
	rts
restore_all:
	and.b	#$fd,$bfe001			; drive

	move.l	sauv_irq,$6c			; reinstalle
	move	#$7fff,$9a(a6)			; systeme
	move	sauv_intena,$9a(a6)
	move	#$7fff,$96(a6)
	move	sauv_dmacon,$96(a6)
	move.l	4,a6
	lea	name_glib,a1
	moveq	#0,d0
	jsr	-552(a6)
	move.l	d0,a0
	move.l	38(a0),$dff080
	clr	$dff088
	move.l	d0,a1
	jsr	-414(a6)
	jsr	-138(a6)
	rts

sauv_dmacon:	dc.l	0
sauv_intena:	dc.l	0
sauv_irq:	dc.l	0
name_glib:	dc.b	"graphics.library",0
		dc.b	0
**********************************************************
tbl_code:
	dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dc.l	4184,3148,0,0,0,0,0,4160
	dc.l	4164,4168,0,0,3156,4172,3152,0,2104,2108
	dc.l	2112,2116,3120,3124,3128,3132,3136,3140,4176,4180
	dc.l	0,0,0,3144,0,0,4,8,12,16
	dc.l	20,24,28,32,36,1040,1044,1048,1052,1056
	dc.l	1060,1064,1068,1072,1076,2080,2084,2088,2092,2096
	dc.l	2100	
message:
	dc.b	8,3,110,5,0
	dc.b	2,16,"  SALUT MC2 ",1,-50,"           ",2,4
	dc.b	" EUREKA PRESENT HIS FIRST SCROLL-TEXT .  YOU"
	DC.B	" THINK IT IS NORMAL BUT NO !            ",2,16
	DC.B	" YEEAAR !",7,1,-100,"            ",2,4
	DC.B	" SUPERBE",8,"            ",3,130,2,8,4,0,7
	DC.B	" ET UNE INTRO UNE !      QUE PENSE TU DU LOGO ?"
	DC.B	"   IL EST BEAU , JE NE SUIS PAS SI MAUVAIS QUE "
	DC.B	" CA EN GRAPHISME .      BIG HELLO TO LAURENT "
	DC.B	"   BON JE NE SAIS PLUS "
	DC.B	" QUOI DIRE ALORS A LA PROCHAINE .............. "
	DC.B	"           ",4,20,0
	even

degrade:
DC.W	$222,$444,$000,$222,$333,$555,$111,$333,$333,$555,$111,$333,$444,$666,$222,$444,$333,$555,$111,$333
DC.W	$444,$666,$222,$444,$555,$777,$333,$555,$444,$666,$222,$444,$555,$777,$333,$555
DC.W	$555,$777,$333,$555,$666,$888,$444,$666,$555,$777,$333,$555,$666,$888,$444,$666
DC.W	$666,$888,$444,$666,$666,$888,$444,$666,$666,$888,$444,$666,$777,$999,$555,$777
DC.W	$666,$888,$444,$666,$777,$999,$555,$777,$777,$999,$555,$777,$777,$999,$555,$777
DC.W	$777,$999,$555,$777,$777,$999,$555,$777,$777,$999,$555,$777,$888,$aaa,$666,$888
DC.W	$777,$999,$555,$777,$888,$aaa,$666,$888,$888,$aaa,$666,$888,$888,$aaa,$666,$888
DC.W	$888,$aaa,$666,$888,$888,$aaa,$666,$888,$888,$aaa,$666,$888,$888,$aaa,$666,$888
DC.W	$888,$aaa,$666,$888,$999,$bbb,$777,$999,$888,$aaa,$666,$888,$999,$bbb,$777,$999
DC.W	$999,$bbb,$777,$999,$999,$bbb,$777,$999,$999,$bbb,$777,$999,$999,$bbb,$777,$999
DC.W	$999,$bbb,$777,$999,$999,$bbb,$777,$999,$999,$bbb,$777,$999,$999,$bbb,$777,$999
DC.W	$999,$bbb,$777,$999,$aaa,$ccc,$888,$aaa,$999,$bbb,$777,$999,$aaa,$ccc,$888,$aaa
DC.W	$aaa,$ccc,$888,$aaa,$aaa,$ccc,$888,$aaa,$aaa,$ccc,$888,$aaa,$aaa,$ccc,$888,$aaa
DC.W	$aaa,$ccc,$888,$aaa,$aaa,$ccc,$888,$aaa,$aaa,$ccc,$888,$aaa,$aaa,$ccc,$888,$aaa
DC.W	$aaa,$ccc,$888,$aaa,$aaa,$ccc,$888,$aaa,$aaa,$ccc,$888,$aaa,$aaa,$ccc,$888,$aaa
DC.W	$bbb,$ddd,$999,$bbb,$aaa,$ccc,$888,$aaa,$bbb,$ddd,$999,$bbb,$bbb,$ddd,$999,$bbb
DC.W	$bbb,$ddd,$999,$bbb,$bbb,$ddd,$999,$bbb,$bbb,$ddd,$999,$bbb,$bbb,$ddd,$999,$bbb
DC.W	$bbb,$ddd,$999,$bbb,$bbb,$ddd,$999,$bbb,$bbb,$ddd,$999,$bbb,$bbb,$ddd,$999,$bbb
DC.W	$bbb,$ddd,$999,$bbb,$bbb,$ddd,$999,$bbb,$bbb,$ddd,$999,$bbb,$bbb,$ddd,$999,$bbb
DC.W	$bbb,$ddd,$999,$bbb,$bbb,$ddd,$999,$bbb,$bbb,$ddd,$999,$bbb,$bbb,$ddd,$999,$bbb
DC.W	$bbb,$ddd,$999,$bbb,$ccc,$eee,$aaa,$ccc,$bbb,$ddd,$999,$bbb,$ccc,$eee,$aaa,$ccc
DC.W	$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc
DC.W	$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc
DC.W	$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc
DC.W	$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc
DC.W	$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc
DC.W	$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc
DC.W	$ccc,$eee,$aaa,$ccc,$ccc,$eee,$aaa,$ccc,$ddd,$fff,$bbb,$ddd,$ccc,$eee,$aaa,$ccc
DC.W	$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd
DC.W	$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd
DC.W	$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd
DC.W	$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd
DC.W	$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd
DC.W	$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd
DC.W	$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd
DC.W	$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd
DC.W	$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd
DC.W	$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd
DC.W	$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd
DC.W	$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd
DC.W	$ddd,$fff,$bbb,$ddd,$ddd,$fff,$bbb,$ddd

image_let:	DC.B	5200,0
		DC.B	5200,0
		DC.B	5200,0

>EXTERN	"FONTE_32*26_1.DAT",IMAGE_LET
>EXTERN	"FONTE_32*26_2.DAT",IMAGE_LET+5200
>EXTERN	"FONTE_32*26_2.DAT",IMAGE_LET+10400

;		incbin	fonte_32*26_1.dat
;		incbin	fonte_32*26_2.dat
;		incbin	fonte_32*26_3.dat
	
logo:
		DC.B	3760,0
		DC.B	3760,0
		DC.B	3760,0

>EXTERN "LOGO_1.DAT",LOGO
>EXTERN "LOGO_2.DAT",LOGO+3760
>EXTERN "LOGO_3.DAT",LOGO+[3760*2]

;		incbin	logo_1.dat
;		incbin	logo_2.dat
;		incbin	logo_3.dat

******************************************************************
pointeur_let:	dc.w	0
perte:		dc.w	20
acceleration:	dc.w	16
y_pos:		dc.w	110*16
vitesse_y:	dc.w	0
stop:		dc.w	0
flag_rebond:	dc.w	0
vitesse:	dc.w	4
pointeur_txt:	dc.w	0
sauve_adr_scro:	dc.l	ecran+[110*44*3]

bss:	
copper_liste:	dC.b	1000,0
tampon_scroll:	dC.b	48*3*26,0
ecran:		DC.B	44*272*3,0
vide:		dC.b	44*3*26,0
		dC.b	50000,0

